/*

rounded text label

arguments: text labelred labelgreen labelblue textred textgreen textblue bgred bggreen bgblue font fontsize roundness padding;
(fontsize is specified as a percentage of height 0.-1.),

*/

outlets = 1;
sketch.default2d();
var mytext = " ";
var mybrgb = [1,0.5,1];
var myfrgb = [1,1,1];
var myrgb2 = [0.5,0.5,0.5];
var sx,sy;
var myfont = "Sans Serif";  // Geneva on Mac, Arial on PC
var myfontsize = 0.1; // relative to height
var myround = 1;
var mypadding = 0.15;
var ltext=['',''];
var increment = 0,x=0;
// process arguments
if (jsarguments.length>1)
    mytext = jsarguments[1];
if (jsarguments.length>2)
    myfrgb[0] = jsarguments[2]/255.;
if (jsarguments.length>3)
    myfrgb[1] = jsarguments[3]/255.;
if (jsarguments.length>4)
    myfrgb[2] = jsarguments[4]/255.;
if (jsarguments.length>5)
    myrgb2[0] = jsarguments[5]/255.;
if (jsarguments.length>6)
    myrgb2[1] = jsarguments[6]/255.;
if (jsarguments.length>7)
    myrgb2[2] = jsarguments[7]/255.;
if (jsarguments.length>8)
    mybrgb[0] = jsarguments[8]/255.;
if (jsarguments.length>9)
    mybrgb[1] = jsarguments[9]/255.;
if (jsarguments.length>10)
    mybrgb[2] = jsarguments[10]/255.;
if (jsarguments.length>11)
    myfont = jsarguments[11];
if (jsarguments.length>12)
    myfontsize = jsarguments[12];
if (jsarguments.length>13)
    myround = jsarguments[13];
if (jsarguments.length>14)
    mypadding = jsarguments[14];

draw();




function fsaa(v)
{
    sketch.fsaa = v;
    draw();
    refresh();
}

function text(v)
{
    mytext = v.toString();
    ltext[increment++]=mytext;
    if (increment>9) 
    { increment =9;
        for (x=1;x<11;x++)    ltext[x-1]=ltext[x];}
    draw();
    refresh();
}


function draw()
{
    var str,width,height,aspect;

    height = box.rect[3] - box.rect[1]; 
    width = box.rect[2] - box.rect[0]; 
    aspect = width/height;

    with (sketch) {
        //erase background
        glclearcolor(0,0,0);
        glclear();
        
        
        moveto(sx*aspect,sy);


        glcolor(1,1,1);
        font(myfont);
        fontsize(myfontsize*height);
        textalign("left","top");
        for (x=0;x<10;x++)
        { 
        moveto(-0.95*aspect,1-(x/5));
        text(ltext[x]);
        }
    }
}

function bang()
{
    draw();
    refresh();
    outlet(0,"bang");
}

function onresize(w,h)
{
    draw();
    refresh();
}
onresize.local = 1; //private

function onclick()
{
    bang();
}
onclick.local = 1; //private
